﻿using System.Collections.Generic;
using AddressSolution.Dto;

namespace AddressSolution.AddressRules
{
    public class ParseAddress
    {
        public List<string> Parse(List<string> addressList)
        {
            List<string> parsedAddressList = new List<string>();
            Address address = new Address();
            foreach (var addressLine in addressList)
            {
                // Parse using rules for each address element
                address.StreetAddress = addressLine;
                address.StreetNumber = RuleStreetNumber.GetStreetNumber(addressLine);
                address.StreetName = RuleStreetName.GetStreetName(addressLine);
                address.StreetType = RuleStreetType.GetStreetType(addressLine);
                address.StreetDirection = RuleStreetDirection.GetStreetDirection(addressLine);
                address.Suite = RuleSuite.GetSuite(addressLine);
                address.Municipality = RuleMunicipality.GetMunicipality(addressLine);
                address.Province = RuleProvince.GetProvince(addressLine);
                address.PostalCode = RulePostalCode.GetPostalCode(addressLine);

                var parsedAddress = string.Join("|", address.StreetAddress, address.StreetNumber, address.StreetName,
                    address.StreetType, address.StreetDirection, address.Suite, address.Municipality,
                    address.Province, address.PostalCode);

                parsedAddressList.Add(parsedAddress);
            }

            return parsedAddressList;
        }
    }
}