﻿using System;
using System.Text.RegularExpressions;

namespace AddressSolution.AddressRules
{
    public static class RulePostalCode
    {
        public static string GetPostalCode(string address)
        {
            // replace comma with space
            string addressLine = address.Trim().Replace(",", " ");
            // PostalCode is now after the last space character
            int lastSpace = addressLine.LastIndexOf(" ", StringComparison.OrdinalIgnoreCase);
            string postalCode = addressLine.Substring(lastSpace).Trim();
            // This is optional
            bool isValid = Regex.IsMatch(postalCode, "\\A[ABCEGHJKLMNPRSTVXY]\\d[A-Z] ?\\d[A-Z]\\d\\z");

            return isValid ? postalCode : "";
        }
    }
}
