﻿using System;
using System.Collections.Generic;
using AddressSolution.Common;

namespace AddressSolution.AddressRules
{
    public static class RuleProvince
    {
        public static string GetProvince(string address)
        {
            List<string> provinces = ValidCollections.GetProvinces();

            // replace comma with space
            string addressLine = address.Trim().Replace(",", " ");

            string province = string.Empty;
            foreach (var prov in provinces)
            {
                int startOfProvince = addressLine.LastIndexOf(prov, StringComparison.OrdinalIgnoreCase);
                if (startOfProvince > -1)
                {
                    province = prov;
                    break;
                }
            }

            return province.Trim();
        }
    }
}