﻿using System;
using System.Collections.Generic;
using AddressSolution.Common;

namespace AddressSolution.AddressRules
{
    public static class RuleStreetDirection
    {
        public static string GetStreetDirection(string address)
        {
            List<string> streetDirections = ValidCollections.GetStreetDirections();

            // replace comma with space
            string addressLine = address.Trim().Replace(",", " ");

            string streetDirection = string.Empty;
            foreach (var stDirection in streetDirections)
            {
                var streetTypeFound = addressLine.IndexOf(stDirection, StringComparison.OrdinalIgnoreCase);
                if (streetTypeFound > -1)
                {
                    streetDirection = stDirection;
                    break;
                }
            }

            return streetDirection.Trim();
        }
    }
}