﻿using System;
using System.Collections.Generic;
using AddressSolution.Common;

namespace AddressSolution.AddressRules
{
    public static class RuleStreetName
    {
        public static string GetStreetName(string address)
        {
            // StreetName is after the first space
            int firstSpace = address.IndexOf(" ", StringComparison.OrdinalIgnoreCase);

            List<string> streetTypes = ValidCollections.GetStreetTypes();

            // replace comma with space
            string addressLine = address.Trim().Replace(",", " ");

            int streetTypeFound = 0;
            foreach (var stType in streetTypes)
            {
                streetTypeFound = addressLine.IndexOf(stType, StringComparison.OrdinalIgnoreCase);
                if (streetTypeFound > -1) break;
            }

            string streetName = string.Empty;
            try
            {
                streetName = addressLine.Substring(firstSpace, streetTypeFound - firstSpace).Trim();
            }
            catch (Exception)
            {
                // Can't parse StreetName
                Console.WriteLine(address);
            }
            return streetName;
        }
    }
}