﻿using System;
using System.Text.RegularExpressions;

namespace AddressSolution.AddressRules
{
    public static class RuleStreetNumber
    {
        public static string GetStreetNumber(string address)
        {
            // StreetNumber is before the first space
            int firstSpace = address.IndexOf(" ", StringComparison.OrdinalIgnoreCase);
            string streetNumber = address.Substring(0, firstSpace).Trim();
            bool isValid = Regex.IsMatch(streetNumber, @"^\d+$");
            return isValid ? streetNumber : "";
        }
    }
}
