﻿using System;
using System.Collections.Generic;
using AddressSolution.Common;

namespace AddressSolution.AddressRules
{
    public static class RuleStreetType
    {
        public static string GetStreetType(string address)
        {
            List<string> streetTypes = ValidCollections.GetStreetTypes();

            // replace comma with space
            string addressLine = address.Trim().Replace(",", " ");

            string streetType = string.Empty;
            foreach (var stType in streetTypes)
            {
                var streetTypeFound = addressLine.IndexOf(stType, StringComparison.OrdinalIgnoreCase);
                if (streetTypeFound > -1)
                {
                    streetType = stType;
                    break;
                }
            }

            return streetType.Trim();
        }
    }
}