﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Data.Entity;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AddressSolution.Dao
{
    public class AddressDBContext : DbContext
    {
        public DbSet<AddrStreetType> StreetTypes { get; set; }
        public DbSet<AddrStreetDirection> StreetDirections { get; set; }
        public DbSet<AddrSuite> Suites { get; set; }
        public DbSet<AddrProvince> Provinces { get; set; }
    }

    public class AddrStreetType
    {
        public int ID { get; set; }
        [MaxLength(10)]
        public string StreetType { get; set; }
    }

    public class AddrStreetDirection
    {
        public int ID { get; set; }
        [MaxLength(5)]
        public string StreetDirection { get; set; }
    }

    public class AddrSuite
    {
        public int ID { get; set; }
        [MaxLength(10)]
        public string Suite { get; set; }
    }

    public class AddrProvince
    {
        public int ID { get; set; }
        [MaxLength(10)]
        public string Province { get; set; }
    }
}
