﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.OleDb;
using System.Configuration;

namespace AddressSolution.Dao
{
    public class ExcelDao
    {
        private static readonly string Folder = ConfigurationManager.AppSettings["excelFolderPath"];
        private static readonly string Filename = ConfigurationManager.AppSettings["excelFilename"];

        private static readonly string FilePath = $@"{Folder}\{Filename}";

        // Older version of Excel
        private readonly string connectionStringXls = $"Provider=Microsoft.Jet.OLEDB.4.0; data source={FilePath}; Extended Properties='Excel 8.0; HDR=No;'";
        // Newer version of Excel
        private readonly string connectionStringXlsx = $"Provider=Microsoft.ACE.OLEDB.12.0;Data Source={FilePath}; Extended Properties='Excel 12.0 Xml; HDR=No;'";

        public List<string> GetExcel()
        {
            string connectionString = Filename.EndsWith(".xls") ? connectionStringXls : connectionStringXlsx;

            var da = new OleDbDataAdapter("SELECT * FROM [Sheet1$]", connectionString);
            var ds = new DataSet();

            try
            {
                da.Fill(ds, "addressTable");
            }
            catch (Exception ex)
            {
                throw new Exception("\nUnable to read excel document...\n" + ex.Message);
            }

            DataTable dataTable = ds.Tables["addressTable"];

            List<string> addressList = new List<string>();

            for (int i = 0; i < dataTable.Rows.Count; i++)
            {
                DataRow dr = dataTable.Rows[i];
                string row = dr[0].ToString();
                addressList.Add(row);
            }

            return addressList;
        }
    }
}
