angular.module('liftApp', ['ui.bootstrap', 'ui.utils', 'ui.router', 'ngAnimate', 'ngMaterial', 'datatables', 'archie', 'configuration']);

angular.module('liftApp').config(function($stateProvider, $urlRouterProvider, $mdThemingProvider) {

    /* Add New States Above */
    $urlRouterProvider.otherwise('/home');
	
    $mdThemingProvider.theme('default')
    .primaryPalette('blue', {
        'default': '800'
    })
    .accentPalette('light-blue', {
        'default': '500'
    })
    .warnPalette('deep-orange')
    .backgroundPalette('grey');	

});

angular.module('liftApp').run(function($rootScope, configurationService) {

    $rootScope.safeApply = function(fn) {
        var phase = $rootScope.$$phase;
        if (phase === '$apply' || phase === '$digest') {
            if (fn && (typeof(fn) === 'function')) {
                fn();
            }
        } else {
            this.$apply(fn);
        }
    };
	
    // Get the version
	configurationService.GetVersion();

});
