﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace ArchieSolution.Extensions
{
    public static class Extensions
    {
        /// <summary>
        /// Converts string to enum
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="value"></param>
        /// <returns></returns>
        public static T ToEnum<T>(this string value)
        {
            // Usage: yourString.ToEnum<yourEnum>();
            if (string.IsNullOrEmpty(value))
            {
                throw new ArgumentNullException("Cannot convert null or empty string to an enum");
            }

            // Get enum from the built-in Parse method
            return (T)Enum.Parse(typeof(T), value, true);
        }
    }
}