﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace ArchieSolution.Models
{
    public class Archie
    {
        // This is an immutable class. All properties must come in via constructor.

        public Archie(Dimension dimension, Skeleton skeleton, Location location, string specimenName)
        {
            this.Dimension = dimension;
            this.Skeleton = skeleton;
            this.Location = location;
            this.SpecimenName = specimenName;
        }

        public Dimension Dimension { get; }
        public Skeleton Skeleton { get; }
        public Location Location { get; }
        public string SpecimenName { get; }
        public decimal TotalWingSpan
        {
            get
            {
                IWingSpan wingSpan = null;

                //switch (this.Skeleton.Wingbone)
                //{
                //    case 0:
                //        wingSpan = new WingboneZero();
                //        break;
                //    case 1:
                //        wingSpan = new WingboneOne();
                //        break;
                //    case 2:
                //        wingSpan = new WingboneTwo();
                //        break;
                //    default:
                //        break;
                //}

                wingSpan = CreateWingboneFactory.CreateInstance(this.Skeleton.Wingbone);

                // Apply Strategy Design Pattern
                Director director = new Director(wingSpan);
                decimal totalWingSpan = director.Calculate(Dimension);
                return totalWingSpan;
            }
        }

    }
}