﻿using System;
using System.Reflection;

namespace ArchieSolution.Models
{
    public class CreateWingboneFactory
    {
        public static IWingSpan CreateInstance(int wingbone)
        {
            string nameSpace = typeof(CreateWingboneFactory).Namespace;
            string className = Enum.GetName(typeof(WingboneClass), wingbone);
            return Assembly.GetExecutingAssembly().CreateInstance(nameSpace + "." + className) as IWingSpan;

            //Object obj = Activator.CreateInstance("ArchieSolution", "ArchieSolution.Models." + className).Unwrap();
            //Object obj = Activator.CreateInstance(Type.GetType("ArchieSolution.Models." + className));
            //return obj as IWingSpan;
        }
    }

    // Class name is case sensitive
    public enum WingboneClass
    {
        WingboneZero = 0,
        WingboneOne = 1,
        WingboneTwo = 2
    }
}