﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace ArchieSolution.Models
{
    public class Dimension : Validation
    {
        [JsonConverter(typeof(StringEnumConverter))]
        public Uom Uom { get; set; }
        [Range(0, int.MaxValue, ErrorMessage = "{0} must be a positive value.")]
        public decimal Height { get; set; }
        [Range(0, int.MaxValue, ErrorMessage = "{0} must be a positive value.")]
        public decimal Width { get; set; }
        [Range(0, int.MaxValue, ErrorMessage = "{0} must be a positive value.")]
        public decimal Length { get; set; }
        [Range(0, int.MaxValue, ErrorMessage = "{0} must be a positive value.")]
        public decimal Girth { get; set; }
        [Range(0, int.MaxValue, ErrorMessage = "{0} must be a positive value.")]
        public decimal WingHandValue { get; set; }
    }
}