﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;

namespace ArchieSolution.Models
{
    public abstract class Validation
    {
        public List<string> Validate()
        {
            List<string> errorList = new List<string>();

            var context = new ValidationContext(this, serviceProvider: null, items: null);
            var results = new List<ValidationResult>();
            var isValid = Validator.TryValidateObject(this, context, results, true);

            if (!isValid)
            {
                foreach (var validationResult in results)
                {
                    Console.WriteLine(validationResult.ErrorMessage);
                    errorList.Add(validationResult.ErrorMessage);
                }
            }
            return errorList;
        }
    }
}