﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TicketCenter_Data;

namespace TicketCenter_DynamicData.DynamicData.CustomPages.TicketsAllocations
{
    public partial class Insert : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                LoadEvents();
                LoadJK();
            }
        }

        private void LoadEvents()
        {
            using (ITCDataContext dc = new ITCDataContext())
            {
                var query = from e in dc.Events
                            select new
                            {
                                e.EventID,
                                e.EventName
                            };

                DropDownList1.DataValueField = "EventID";
                DropDownList1.DataTextField = "EventName";

                DropDownList1.DataSource = query;
                DropDownList1.DataBind();
            }
        }

        private void LoadJK()
        {
            PlaceHolder1.Controls.Add(new LiteralControl("<table><tr><td>"));

            using (ITCDataContext dc = new ITCDataContext())
            {
                var query = from j in dc.JKs select j;
                foreach (var q in query)
                {
                    Label label = new Label();
                    label.Text = q.Name;
                    label.ID = "Lbl" + q.Name;
                    //form1.Controls.Add(label);
                    //form1.Controls.Add(new LiteralControl("&nbsp;&nbsp;&nbsp;"));
                    PlaceHolder1.Controls.Add(label);
                    PlaceHolder1.Controls.Add(new LiteralControl("</td><td>"));

                    TextBox textbox = new TextBox();
                    textbox.ID = "Txt" + q.Name;
                    textbox.Text = "0";
                    //form1.Controls.Add(textbox);
                    //form1.Controls.Add(new LiteralControl("\r\n<br /> \r\n"));
                    PlaceHolder1.Controls.Add(textbox);
                    PlaceHolder1.Controls.Add(new LiteralControl("</td></tr>\r\n<tr><td>"));
                }
                PlaceHolder1.Controls.Add(new LiteralControl("</td></tr></table>"));
                PlaceHolder1.Controls.Add(new LiteralControl("\r\n<br /> \r\n"));
            }
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            GetJKvalues();
            SaveToDB();

            Response.Redirect("~/TicketsAllocations/List.aspx");
        }

        private Dictionary<int, string> dict;
        private void GetJKvalues()
        {
            string[] AllKeys = Request.Form.AllKeys;

            dict = new Dictionary<int, string>();
            using (ITCDataContext dc = new ITCDataContext())
            {
                var query = from j in dc.JKs select j;
                foreach (var q in query)
                {
                    foreach (string s in AllKeys)
                    {
                        if (s.EndsWith("Txt" + q.Name))
                        {
                            string val = Request.Form[s];
                            if (val != string.Empty)
                                dict.Add(q.JKID, val);
                            break;
                        }
                    }

                }
            }

            //DropDownList1.Visible = false;
            //Button1.Visible = false;
            //Response.Write(DropDownList1.SelectedItem);
            //Response.Write("<br />");
            //foreach (var d in dict)
            //{
            //    Response.Write(d.Key);
            //    Response.Write("&nbsp;&nbsp;&nbsp;");
            //    Response.Write(d.Value);
            //    Response.Write("<br />");
            //}
        }

        private void SaveToDB()
        {
            using (ITCDataContext dc = new ITCDataContext())
            {
                foreach (var d in dict)
                {
                    TicketsAllocation ta = new TicketsAllocation();
                    ta.JKID = d.Key;
                    ta.EventID = (Convert.ToInt32(DropDownList1.SelectedValue));
                    ta.TicketsIssued = Convert.ToInt32(d.Value);
                    ta.TotalTicketsSold = 0;
                    ta.TicketsCommited = 0;
                    dc.TicketsAllocations.InsertOnSubmit(ta);
                }
                dc.SubmitChanges();
            }
        }
    }
}
