﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml.Linq;
using System.Web.DynamicData;
using Aspnet.Samples.DynamicData;

namespace TicketCenter_DynamicData
{
    public partial class Details : System.Web.UI.Page
    {
        protected MetaTable table;

        protected void Page_Init(object sender, EventArgs e)
        {
            DynamicDataManager1.RegisterControl(DetailsView1);
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            table = DetailsDataSource.GetTable();
            Title = table.DisplayName;
            ListHyperLink.NavigateUrl = table.ListActionPath;

            DetailsView1.PreRender += new EventHandler(DetailsView1_PreRender);
        }

        protected void DetailsView1_ItemDeleted(object sender, DetailsViewDeletedEventArgs e)
        {
            if (e.Exception == null || e.ExceptionHandled)
            {
                Response.Redirect(table.ListActionPath);
            }
        }

        void DetailsView1_PreRender(object sender, EventArgs e)
        {
            int rowCount = DetailsView1.Rows.Count;
            SetDelete(DetailsView1.Rows[rowCount - 1]);
        }

        private void SetDelete(TableRow row)
        {
            // Instantiate the SecurityInformation utility object.
            DynamicDataSecurity secInfo = new DynamicDataSecurity();

            if (secInfo.IsUserInAdmimistrativeRole())
                return;

            string[] roles = Roles.GetAllRoles();

            foreach (Control c in row.Cells[1].Controls)
            {
                for (int i = 0; i < roles.Length; i++)
                {
                    if (Roles.IsUserInRole(roles[i]))
                    // if (Roles.IsUserInRole("Clerks"))
                    {
                        LinkButton btn = c as LinkButton;
                        if (btn != null && btn.CommandName == DataControlCommands.DeleteCommandName)
                        {
                            btn.Visible = false;
                            btn.OnClientClick = null;
                            btn.Enabled = false;
                        }
                    }
                }
            }
        }
    }
}
